#!/usr/bin/python

#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#

#
# Copyright (c) 2010, 2015, Oracle and/or its affiliates. All rights reserved.
#

# aspects of pkglint configuration

import ConfigParser
import os

defaults = {
    "log_level": "INFO",
    "do_pub_checks": "True",
    "ignore_different_publishers": "True",
    "info_classification_path":
        "/usr/share/lib/pkg/opensolaris.org.sections",
    "use_progress_tracker": "True",
    "pkglint.ext.opensolaris": "pkg.lint.opensolaris",
    "pkglint.ext.pkglint_actions": "pkg.lint.pkglint_action",
    "pkglint.ext.pkglint_manifests": "pkg.lint.pkglint_manifest",
    "pkglint.exclude": None,
    "version.pattern": "*,5.11-0."
    }

class PkglintConfigException(Exception):
        """An exception thrown when something fatal happens while reading the
        config.
        """
        def __unicode__(self):
                # To workaround python issues 6108 and 2517, this provides a
                # a standard wrapper for this class' exceptions so that they
                # have a chance of being stringified correctly.
                return str(self)

class PkglintConfig(object):
        def __init__(self, config_file=None):

                if config_file:
                        try:
                                # ConfigParser doesn't do a good job of
                                # error reporting, so we'll just try to open
                                # the file
                                file(config_file, "r").close()
                        except (EnvironmentError) as err:
                                raise PkglintConfigException(
                                    _("unable to read config file: {0} ").format(
                                    err))
                try:
                        self.config = ConfigParser.SafeConfigParser(defaults)
                        if not config_file:
                                self.config.readfp(
                                    open("/usr/share/lib/pkg/pkglintrc"))
                                self.config.read(
                                    [os.path.expanduser("~/.pkglintrc")])
                        else:
                                self.config.read(config_file)

                        # sanity check our config by looking for a known key
                        self.config.get("pkglint", "log_level")
                except ConfigParser.Error as err:
                        raise PkglintConfigException(
                            _("missing or corrupt pkglintrc file "
                            "{config_file}: {err}").format(**locals()))
